﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="MediaUsageReport.aspx.cs" Inherits="ImageVault.EPiServer.UI.Reports.MediaUsageReport" %>
<%@ Import Namespace="EPiServer.Cms.Shell" %>
<asp:Content ContentPlaceHolderID="FullRegion" Runat="Server">
    <%= IvScriptIncludes %>
    <script>
        function selectMediaIds(insertMultiple) {
            //Create a window-name
            var name = "noname".replace(new RegExp("-", "g"), '_');
            //Open Iv dialog
            window.open('<%=IvDialogUrl%>&formatId=1&insertMultiple=true', name, 'width=1034,height=768,resizable=yes,scrollbars');
            ImageVault.UiCallback.Instance.RegisterOpener(name, insertMultiple, function (data) {
                //Push the selected mediaIds into the selection field
                var mId = document.getElementById('FullRegion_selectMediaID');
                mId.value = $.map(data, function (elm) {
                    return elm.Id;
                }).join(',');
             });
        }
    </script>
<div class="epi-contentContainer epi-padding">
    <div class="epi-contentArea">
        <div class="EP-systemImage" style="background-image: url('<%=IconUrl%>');">
	        <h1 class="EP-prefix">
        		<%= UiStringDictionary["Title"] %><br/>
                <%--ToDo: Implementera- och aktivera hjälp-länk--%>
                <%--<a onclick="window.open('http://webhelp.episerver.com/cms/7.5/sv/Default_csh.htm#expiredpages','_blank', 'scrollbars=yes, height=500, location=no, menubar=no, resizable=yes, toolbar=no, width=840');return false;" title="Hjälp" href="http://webhelp.episerver.com/cms/7.5/sv/Default_csh.htm#expiredpages" target="_blank"><img class="EPEdit-CommandTool" align="absmiddle" src="/App_Themes/Default/Images/Tools/Help.png" border="0" alt="Hjälp"></a>--%>
	        </h1>
            <p class="EP-systemInfo"><%=UiStringDictionary["Description"]%><br/>
                <%=UiStringDictionary["VerboseDescription"]%>
            </p>
        </div>
        <div id="FullRegion_ValidationSummary" class="EP-validationSummary" style="color:Black;display:none;">
        </div>
    </div>
    <div class="epi-formArea">
        <fieldset>
            <legend>
                <%=UiStringDictionary["Criterias"]%>
            </legend>
            <div class="epi-size15">
                <div>
                    <label for="SelectionRegion_SearchWasteBasket"><%=UiStringDictionary["SearchWasteBasket"]%></label>
                    <asp:CheckBox ID="SelectionRegion_SearchWasteBasket" Checked="False" runat="server" />
                </div>
                <div>
                    <label for="SelectionRegion_SearchHistoricalVersions"><%=UiStringDictionary["SearchHistoricalVersions"]%></label>
                    <asp:CheckBox ID="SelectionRegion_SearchHistoricalVersions" Checked="False" runat="server" />
                </div>
                <div id="SelectionRegion_LanguageDiv">    
                    <label for="SelectionRegion_LanguageSelector"><%=UiStringDictionary["Language"]%></label>
                     <asp:DropDownList id="SelectionRegion_LanguageSelector" class="episize240" runat="server">
                    </asp:DropDownList>   
                 </div>
                <div>
                    <label for="selectMediaID">
                        <%=UiStringDictionary["MediaId"]%>
                    </label>
                    <input class="episize240" id="selectMediaID" name="selectMediaID" type="text" runat="server">
                    <input id="selectMedia" type="button" value="..." class="epismallbutton" onclick="selectMediaIds(true);">
                </div>
            </div>         
        </fieldset>
    
        <div class="epitoolbuttonrow">
            <span class="epi-cmsButton">
                <asp:Button runat="server" ID="buttonShowReport" CssClass="epi-cmsButton-text epi-cmsButton-tools epi-cmsButton-Report" OnClick="buttonShowReport_OnClick"/>
            </span>
        </div>
        
        <div class="epi-floatRight epi-marginVertical-small">
            <label for="PageSizeSelector"><%=UiStringDictionary["Pagination"]%></label>
            <asp:DropDownList runat="server" ID="PageSizeSelector" AutoPostBack="True" OnSelectedIndexChanged="PageSizeSelector_OnSelectedIndexChanged" runat="server">
                <asp:ListItem>10</asp:ListItem>
                <asp:ListItem>25</asp:ListItem>
                <asp:ListItem>50</asp:ListItem>
                <asp:ListItem>100</asp:ListItem>
            </asp:DropDownList>
        </div> 
         <%
             if (IsPostBack || IsDirectLink) {
                 %>
        <div class="epi-floatLeft epi-marginVertical-small">
            <asp:Literal ID="NumberOfHits" runat="server" Visible="False"/>
        </div>
        <div class="epi-contentArea epi-clear">
            <div>
                <asp:GridView ID="reportGrid" CssClass="epi-default epi-default-legacy"
                    AutoGenerateColumns="False"
                    CellSpacing="0"
                    Style="border-style: none; border-collapse: collapse; width: 100%;"
                    runat="server"
                    OnPageIndexChanging="reportGrid_OnPageIndexChanging"
                    AllowSorting="True"
                    OnSorting="reportGrid_OnSorting">
                    <Columns>
                        <asp:HyperLinkField DataTextField="Name" DataNavigateUrlFields="Name" HeaderText="Name" SortExpression="Name"/>
                        <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status"/>
                        <asp:BoundField DataField="LastChanged" HeaderText="Last Changed" SortExpression="LastChanged"/>
                        <asp:BoundField DataField="ChangedBy" HeaderText="Changed By" SortExpression="ChangedBy"/>
                        <asp:BoundField DataField="Language" HeaderText="Language" SortExpression="Language"/>
                    </Columns>
                </asp:GridView>
                <%
                    }
                %>
            </div>
        </div> 
    </div>    
</div>
</asp:Content>

